var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useDeep, useTokenController } from "@deep-foundation/deeplinks";
import Debug from 'debug';
import React, { useEffect, useState } from "react";
const debug = Debug('perception:auto-guest');
export const AutoGuest = React.memo(function AutoGuest({ children, }) {
    const deep = useDeep();
    const [token] = useTokenController();
    const [isAuth, setIsAuth] = useState(false);
    useEffect(() => {
        const isAuth = !!((deep === null || deep === void 0 ? void 0 : deep.linkId) && token && token === deep.token);
        debug('useCheckAuth', 'token', token, 'deep.token', deep === null || deep === void 0 ? void 0 : deep.token, 'isAuth', isAuth);
        if (isAuth)
            (() => __awaiter(this, void 0, void 0, function* () {
                var _a;
                const result = yield deep.select({ id: deep.linkId });
                if (!((_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.length)) {
                    debug(`user ${deep.linkId} invalid`);
                    deep.logout();
                }
                else {
                    debug(`user ${deep.linkId} valid`);
                }
            }))();
        if (!token)
            (() => __awaiter(this, void 0, void 0, function* () {
                const g = yield deep.guest();
                debug(`guest ${deep.linkId} inserted and logged in`);
            }))();
        setIsAuth(isAuth);
    }, [token, deep === null || deep === void 0 ? void 0 : deep.linkId]);
    return React.createElement(React.Fragment, null, isAuth ? children || null : null);
});
//# sourceMappingURL=auto-guest.js.map