import { Id, Link, DeepClient } from '@deep-foundation/deeplinks';
import React from 'react';
import { GoContextI } from './go.js';
export declare class CatchErrors extends React.Component<{
    error?: any;
    onMounted?: (setError: (error?: any) => void) => void;
    errorRenderer?: (error: Error, reset: () => any, catcher: any) => React.ReactNode;
    reset?: () => any;
    children: any;
}, any> {
    reset: () => any;
    constructor(props: any);
    static getDerivedStateFromError(error: any): {
        error: any;
    };
    componentDidCatch(error: any, errorInfo: any): void;
    componentDidMounted(): void;
    errorRenderer: (error: any, reset: any, catcher: any) => React.JSX.Element;
    render(): any;
}
export declare function evalClientHandler(options: {
    value: string;
    deep: DeepClient;
    input?: any;
}): Promise<{
    error?: any;
    data?: any;
}>;
export declare const HandlersGoContext: GoContextI;
export declare function useHandlersGo(): import("./go.js").GoI;
export declare const ClientHandler: React.NamedExoticComponent<ClientHandlerProps>;
export declare const HandlerConfigContext: React.Context<{
    sync: boolean;
    setSync: React.Dispatch<React.SetStateAction<boolean>>;
}>;
export declare function useClientHandler(_props: UseClientHandlerProps): {
    data: any;
    handlerId: Id;
    file: Link<Id>;
    sync: boolean;
    errored: any;
    outerError: any;
    erroredResetRef: React.MutableRefObject<any>;
    setErrorRef: React.MutableRefObject<any>;
    link: any;
    linkId: any;
    require: any;
    reloadHandler: () => void;
    handlerQuery?: any;
    Component?: any;
    fillSize?: boolean;
    context?: Id[];
    error?: any;
    onClose?: () => any;
};
export interface ClientHandlerRendererProps {
    Component: any;
    fillSize?: boolean;
    onClose?: () => any;
    [key: string]: any;
}
export declare const ClientHandlerRenderer: React.NamedExoticComponent<ClientHandlerRendererProps>;
export interface ClientHandlerProps extends Partial<ClientHandlerRendererProps> {
    linkId?: Id;
    handlerId?: Id;
    handlerQuery?: any;
    context?: Id[];
    error?: any;
    onClose?: () => any;
    ErrorComponent?: (props: ClientHandlerProps) => any;
    UnhandledComponent?: (props: ClientHandlerProps) => any;
    sync?: boolean;
    [key: string]: any;
}
export interface UseClientHandlerProps extends Partial<ClientHandlerRendererProps> {
    linkId?: Id;
    handlerId?: Id;
    handlerQuery?: any;
    context?: Id[];
    error?: any;
    onClose?: () => any;
    sync?: boolean;
    [key: string]: any;
}
export declare function useFindClientHandler({ handlerId, handlerQuery, context, }: {
    handlerId?: Id;
    handlerQuery?: any;
    context?: Id[];
}): {
    handler: any;
    reloadHandler: () => void;
    counter: number;
};
